<?php
	// Exit if accessed directly
	if( !defined( 'ABSPATH' ) ) exit;
	
	class mg2wpForo_dwqa extends wpForoMg2Board{
		public function get_users_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM ".$this->db->base_prefix."users") ) return $count;
			return 0;
		}
		
		public function get_forums_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM `".$this->db->prefix."term_taxonomy` WHERE `taxonomy` LIKE 'dwqa-question_category'") ) return $count;
			return 0;
		}
		
		public function get_topics_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM ".$this->db->prefix."posts WHERE post_status IN('publish', 'private') AND post_type LIKE 'dwqa-question'") ) return $count;
			return 0;
		}
		
		public function get_posts_count(){
			if( $count = $this->db->get_var("SELECT COUNT(*) FROM ".$this->db->prefix."posts WHERE post_status IN('publish', 'private') AND post_type LIKE 'dwqa-answer'") ) return $count + $this->get_topics_count();
			return 0;
		}
		
		public function get_forums(){
			$sql = "SELECT tt.`term_taxonomy_id` AS old_id, 
					t.`name` AS title, 
					t.`slug` AS slug, 
					tt.`description` AS description, 
					tt.`parent` AS parentid 
				FROM `".$this->db->prefix."term_taxonomy` tt
				INNER JOIN `".$this->db->prefix."terms` t ON t.`term_id` = tt.`term_id`
				WHERE tt.`taxonomy` LIKE 'dwqa-question_category'
				ORDER BY parentid, old_id";
			return $this->db->get_results($sql, ARRAY_A);
		}
		
		public function get_topics($lastid = 0){
			$sql = "SELECT p.ID AS old_id, 
					p.post_author AS userid, 
					p.post_title AS title, 
					p.post_name AS slug, 
					p.post_content AS body, 
					MIN(tr.`term_taxonomy_id`) AS forumid, 
					p.post_date AS created 
				FROM ".$this->db->prefix."posts p
				INNER JOIN `".$this->db->prefix."term_relationships` tr ON tr.`object_id` = p.`ID`
				INNER JOIN `".$this->db->prefix."term_taxonomy` tt ON tt.`term_taxonomy_id` = tr.`term_taxonomy_id` AND tt.`taxonomy` LIKE 'dwqa-question_category'
				WHERE p.ID > $lastid
					AND p.post_status IN('publish', 'private') 
					AND p.post_type = 'dwqa-question'
				GROUP BY old_id
				ORDER BY old_id";
			return $this->db->get_results($sql.$this->limit, ARRAY_A);
		}
		
		public function get_replies($lastid = 0){
			$sql = "SELECT p.`ID` AS old_id, 
				p.`post_author` AS userid, 
				CONCAT('Answer: ', p.`post_title`) AS title, 
				p.`post_content` AS body, 
				pm.`meta_value` AS topicid, 
				p.`post_date` AS created
			FROM `".$this->db->prefix."posts` p
			INNER JOIN `".$this->db->prefix."postmeta` pm ON pm.`post_id` = p.`ID` AND pm.`meta_key` = '_question'
			WHERE p.`ID` > $lastid
				AND p.post_status IN('publish', 'private') 
				AND p.`post_type` LIKE 'dwqa-answer' 
			ORDER BY old_id";
			return $this->db->get_results($sql.$this->limit, ARRAY_A);
		}
		
	}
	
	$mg2wpforo->dwqa = new mg2wpForo_dwqa();
?>