<?php
	// Exit if accessed directly
	if( !defined( 'ABSPATH' ) ) exit;
	
	function mg2wpforo_init(){
		global $wpforo;
		if( !is_null($wpforo) ){
			$GLOBALS['mg2wpforo'] = new Migrate2wpForo($wpforo);
		}else{
			add_action( 'admin_notices', 'mg2wpforo_admin_notice__error' );
		}
	}
	add_action('plugins_loaded', 'mg2wpforo_init');
	
	register_activation_hook(MG2WPFORO_BASENAME, 'do_mg2wpforo_activation');
	function do_mg2wpforo_activation($network_wide){
		if ( is_multisite() && $network_wide ) { 
	        global $wpdb;
			
	        $old_blogid = $wpdb->blogid;
	        $blogids = $wpdb->get_col("SELECT blog_id FROM {$wpdb->blogs}");
	        foreach ($blogids as $blogid){
	            switch_to_blog($blogid);
	            mg2wpforo_activation();
	        }
	        switch_to_blog($old_blogid);
	    }else{
	        mg2wpforo_activation();
	    }
	}
	
	function mg2wpforo_activation(){
		global $wpdb;
		$sql = "CREATE TABLE IF NOT EXISTS " . $wpdb->prefix . "mg2wpforo(
			id SERIAL PRIMARY KEY,
			obj VARCHAR(20) NOT NULL,
			old_id BIGINT UNSIGNED NOT NULL,
			new_id BIGINT UNSIGNED NOT NULL,
			UNIQUE KEY unqdata(obj,old_id),
			KEY(obj,old_id,new_id)
		)ENGINE = MyISAM";
		$wpdb->query($sql);
		$sql = "TRUNCATE ".$wpdb->prefix."mg2wpforo";
		$wpdb->query($sql);
		$sql = "ALTER TABLE " . $wpdb->prefix . "wpforo_topics ENGINE = MyISAM";
		$wpdb->query($sql);
		$sql = "ALTER TABLE " . $wpdb->prefix . "wpforo_posts ENGINE = MyISAM";
		$wpdb->query($sql);
	}
	
	function mg2wpforo_admin_notice__error() {
		$class = 'notice notice-error';
		$message = __( 'Migrate2wpForo Notice: Please activate required <a href="http://wpforo.com">wpForo plugin</a> otherwise <b>Migrate2wpForo</b> will not work', 'mg2wpforo' );
		printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
	}
	
	function mg2wpforo_init_action($board){
		global $mg2wpforo; ?>
		
		<h1 style="color: gray"><?php echo strtoupper($board) ?> to wpForo migration</h1><br />
		
		<?php 
			if( !($mg2wpforo->$board->get_forums_count() + $mg2wpforo->$board->get_topics_count() + $mg2wpforo->$board->get_posts_count()) ){
				mg2wpforo_admin_notice__no_forum_found();
				return; 
			}
		?>
		
		<div style="margin: 10px;">
			
			<?php if( isset($_GET['convert']) ) : ?>
				
				<center>
					<img src="<?php echo MG2WPFORO_URL ?>/loading.gif"/><br/>
					<span style="color: lightgreen; font-size: 3em;">Processing <b><?php echo strtoupper( $_GET['convert'] ) ?></b> migration . . .</span><br/><br/>
					<span style="color: red; font-size: 3em;">don't stop or close your browser</span><br/><br/>
					<!--<span style="color: lightgreen; font-size: 3em;"><?php echo $mg2wpforo->get_progress_percent($board) ?>%</span><br/><br/>-->
					<?php $mg2wpforo->show_progress_bar($board) ?>
				</center>
				
			<?php else : ?>
				
				<fieldset style="border: 1px solid black; padding: 25px;">
					<legend style="margin-left: 5px; font-weight: bold; font-size: 2em">Statistics</legend>
					<?php $mg2wpforo->show_statistics_table($board) ?>
				</fieldset>
				<br />
				<form action="<?php echo wpforo_get_request_uri() ?>" method="get" onsubmit="return confirm('if you are doing again this action for this forum will be duplicated ( click CANCEL for break action or click OK for the continuing )');">
					<fieldset style="border: 1px solid black; padding: 25px;">
						<legend style="margin-left: 5px; font-weight: bold; font-size: 2em">Import Options</legend>
						<input type="hidden" name="page" value="<?php echo $board ?>-mg2wpforo"/>
						<input type="hidden" name="convert" value="forum"/>
						<table width="100%">
							<tr>
								<td align="left"><label id="layout">Import Forums to wpForo Current Theme Layout</label></td>
								<td align="right">
									<select id="layout" name="layout">
										<?php $mg2wpforo->wpforo->tpl->show_layout_selectbox() ?>
									</select>
								</td>
							</tr>
							<tr>
								<td align="left"><label for="itempercycle">Items to import per cycle (must be greater then 1)</label></td>
								<td align="right"><input style="width: 96px;" id="itempercycle" type="number" min="1" name="itempercycle" value="200"/></td>
							</tr>
						</table>
					</fieldset>
					<input type="hidden" name="action" value="show"/>
					<input class="button button-primary" style="float: right; margin-top: 20px; width: 500px; height: 50px; font-size: 2em;" type="submit" value="Start Migration"/>
				</form>
				
			<?php endif ?>
			
		</div>
		
		<?php
	}
	
	function mg2wpforo_do_actions(){
		if( !wpforo_is_admin() ) return;
		if( isset($_GET['page']) && strpos($_GET['page'], '-mg2wpforo') !== FALSE && $board = trim(basename($_GET['page'], '-mg2wpforo')) ){
			global $mg2wpforo;
			if( isset($_GET['itempercycle']) ) $mg2wpforo->itempercycle = intval($_GET['itempercycle']);
			require_once( MG2WPFORO_DIR . "/includes/board.php" );
			require_once( MG2WPFORO_DIR . "/boards/$board.php" );
			
			if( isset($_GET['convert']) && isset($_GET['action']) ){
				if( $_GET['convert'] == 'forum' ) $mg2wpforo->clear_log();
				
				if( $_GET['action'] == 'do' ){
					$search = array('&action=do');
					$replace = array('&action=show');
					if( $_GET['convert'] == 'forum' ){
						$mg2wpforo->wpforo->member->synchronize_users();
						$mg2wpforo->wpforo->member->init_current_user();
						$mg2wpforo->do_forums($board);
						$search[] = '&convert=forum';
						$replace[] = '&convert=topic';
					}elseif( $_GET['convert'] == 'topic' ){
						if( $mg2wpforo->do_topics($board) ){
							$search[] = '&convert=topic';
							$replace[] = '&convert=reply';
						}
					}elseif( $_GET['convert'] == 'reply' ){
						if( $mg2wpforo->do_replies($board) ){
							wp_redirect( admin_url( 'admin.php?page=' . $_GET['page'] . '&mg2wpforo=finish' ) );
							exit();
						}
					}
					wp_redirect( str_replace($search, $replace, wpforo_get_request_uri()) );
					exit();
				}elseif( $_GET['action'] == 'show' ){
					header( "refresh:0.1;url=" . str_replace('&action=show', '&action=do', wpforo_get_request_uri()) );
				}
			}
			
			if( isset($_GET['mg2wpforo']) ){
				add_action( 'admin_notices', 'mg2wpforo_admin_notice__finish' );
			}
		}
	}
	add_action('init', 'mg2wpforo_do_actions', 11);
	
	function mg2wpforo_admin_notice__finish(){
		$class = 'notice';
		$message = '';
		if($_GET['mg2wpforo'] == 'finish'){
			$class = 'notice notice-success ';
			$message = __( 'Migrate2wpForo Notice: Successfully Finished', 'mg2wpforo' );
		}
		printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message ); 
	}
	
	function mg2wpforo_admin_notice__no_forum_found(){
		$class = 'notice notice-warning ';
		$message = __( 'Migrate2wpForo Notice: We can\'t find this board on this system', 'mg2wpforo' );
		printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );
	}
?>